# Copyright 2021 Le Filament (<http://www.le-filament.com>)
# License AGPL-3.0 or later (http://www.gnu.org/licenses/agpl.html).

import base64
import csv
import io

from odoo import fields, models, api


class MembershipImport(models.TransientModel):
    _name = 'afac.membership.import.wizard'
    _description = 'Wizard import adhésions'

    file = fields.Binary('CSV File', required=True)
    filename = fields.Char('Filename')

    def import_data(self):
        data = base64.b64decode(self.file).decode('utf-8')
        reader = csv.DictReader(io.StringIO(data), delimiter=';')
        contact = line = 0
        for row in reader:
            for year in range(2021, 2022, 1):
                year = str(year)
                print(row.get(year))
                if row.get(year) and int(row.get(year)) > 0:
                    partner = self.env['res.partner'].search([('membership_number', '=', int(row.get('ADH')))])
                    product = self.env['product.product'].sudo().search([
                        ('name', 'ilike', year),
                        '|',
                        ('company_id', '=', int(row.get('company_id'))),
                        ('company_id', '=', None)
                    ])
                    print(partner)
                    print(product)
                    begin = str(year) + '-01-01'
                    end = str(year) + '-12-31'
                    if year == 2021 and row.get('date_membership'):
                        date_membership = row.get('date_membership')
                    else:
                        date_membership = begin
                    req = """
                        INSERT INTO membership_membership_line(partner, date_from, date_to, date, member_price, state, company_id, membership_id)
                        VALUES (
                            %d, '%s', '%s', '%s', %d, '%s', %d, %d
                        )""" % (partner.id, begin, end, date_membership,
                                int(row.get(year)), 'paid', int(row.get('company_id')), product.id)
                    print(req)
                    self.env.cr.execute(req)
                    line += 1
            contact += 1
        return

